package final_risk;

import java.util.Observable;
import java.util.Random;

/**
 *  <font face="">Cuando es el momento de jugar: </font>
 *      
 *          <p style="margin-top: 0">
 *        <font face="">1.- Crea el tablero. </font><br><font face="">2.- Se 
 *        asigna territorios y cartas a los jugadores. </font><br>3.- Se tira los 
 *        dados.<br>4.- Controla las acciones (Atacar, defender, tranferir 
 *        ejercitos).<br>5.- Controla el cambio de jugador (fin del turno).<br>6.- 
 *        Muestra por pantalla el ganador.<br>
 *          </p>
 */
// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.BE1EE0A4-09F2-5B19-02C0-D8B08AE51BC6]
// </editor-fold> 
public class Juego_Principal extends Observable {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.01A4084A-5663-19FD-D5BC-2D52FB063431]
    // </editor-fold> 
    private int num_jugadores;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0CA6C2E5-3786-3B7E-4D01-A44948F06BFC]
    // </editor-fold> 
    private int modo_juego;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CCEE069F-91B2-B008-5BF5-B1CDB27207FD]
    // </editor-fold> 
    private Jugador jugadores[];

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.A8DFA0CC-C853-3941-40D5-958BA8A018A9]
    // </editor-fold> 
    private Territorios t1[];

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.7F52BEEA-C585-EEA0-EDF9-A87118061E31]
    // </editor-fold> 
    private Dados mDados;
    
    Misiones_Secretas mision[];


    //Devuelve la misin que tiene que cumplir el jugador.
    public Misiones_Secretas getMision(int val) {
        return mision[val];
    }


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.58B9BDB8-15F8-5ACA-9C07-57502DBB4FF8]
    // </editor-fold> 
    @SuppressWarnings("empty-statement")
    public Juego_Principal(/*int n_jug*/) {
       /* this.nContinentes = 6;
        this.num_jugadores = n_jug;
        jugadores = new Jugador[num_jugadores];
        

        for (int i = 0; i < num_jugadores; i++) {
            int num = i + 1;
            jugadores[i] = new Jugador("Jugador" + num, num);
        }*/
        
        Random rnd = new Random();        
        
        //Creamos las misiones
        this.mision= new Misiones_Secretas[6];
        
        this.mision[0]= new Misiones_Secretas(1,"Conquista America del Norte y Africa","Conquest America del Norte and Africa","America del Norte","Africa",9,6);
        this.mision[1]= new Misiones_Secretas(2,"Conquista Asia y America del Sur","Conquest Asia and America del Sur","Asia","America del Sur",12,4);
        this.mision[2]= new Misiones_Secretas(3,"Conquista America del Norte y Europa","Conquest America del Norte and Europa","America del Norte","Europa",9,7);
        this.mision[3]= new Misiones_Secretas(4,"Conquista Asia y Australia","Conquest Asia and Australia","Asia","Australia",12,4);
        this.mision[4]= new Misiones_Secretas(5,"Conquista Europa y Australia","Conquest Europa and Australia","Europa","Australia",7,4);
        this.mision[5]= new Misiones_Secretas(6,"Conquista America del Sur y Africa","Conquest America del Sur and Africa","America del Sur","Africa",4,6);                
        
        //Creamos los continentes y territorios
        t1 = new Territorios[42];
        //America del Norte

        int[] v1 = new int[3];
        v1[0] = 2;
        v1[1] = 6;
        v1[2] = 25;
        int[] v2 = new int[4];
        v2[0] = 1;
        v2[1] = 6;
        v2[2] = 7;
        v2[3] = 9;
        int[] v3 = new int[3];
        v3[0] = 4;
        v3[1] = 9;
        v3[2] = 13;
        int[] v4 = new int[4];
        v4[0] = 3;
        v4[1] = 7;
        v4[2] = 8;
        v4[3] = 9;
        int[] v5 = new int[4];
        v5[0] = 6;
        v5[1] = 7;
        v5[2] = 8;
        v5[3] = 28;
        int[] v6 = new int[4];
        v6[0] = 1;
        v6[1] = 2;
        v6[2] = 5;
        v6[3] = 7;
        int[] v7 = new int[6];
        v7[0] = 2;
        v7[1] = 4;
        v7[2] = 5;
        v7[3] = 6;
        v7[4] = 8;
        v7[5] = 9;
        int[] v8 = new int[3];
        v8[0] = 4;
        v8[1] = 5;
        v8[2] = 7;
        int[] v9 = new int[4];
        v9[0] = 2;
        v9[1] = 3;
        v9[2] = 4;
        v9[3] = 7;
        int[] v10 = new int[2];
        v10[0] = 11;
        v10[1] = 12;
        int[] v11 = new int[4];
        v11[0] = 10;
        v11[1] = 12;
        v11[2] = 13;
        v11[3] = 18;
        int[] v12 = new int[3];
        v12[0] = 10;
        v12[1] = 11;
        v12[2] = 13;
        int[] v13 = new int[3];
        v13[0] = 3;
        v13[1] = 11;
        v13[2] = 12;
        int[] v14 = new int[3];
        v14[0] = 15;
        v14[1] = 18;
        v14[2] = 19;
        int[] v15 = new int[5];
        v15[0] = 14;
        v15[1] = 16;
        v15[2] = 17;
        v15[3] = 18;
        v15[4] = 19;
        int[] v16 = new int[4];
        v16[0] = 15;
        v16[1] = 18;
        v16[2] = 26;
        v16[3] = 31;
        int[] v17 = new int[2];
        v17[0] = 15;
        v17[1] = 19;
        int[] v18 = new int[6];
        v18[0] = 11;
        v18[1] = 14;
        v18[2] = 15;
        v18[3] = 16;
        v18[4] = 31;
        v18[5] = 33;
        int[] v19 = new int[3];
        v19[0] = 14;
        v19[1] = 15;
        v19[2] = 17;
        int[] v20 = new int[5];
        v20[0] = 21;
        v20[1] = 22;
        v20[2] = 26;
        v20[3] = 32;
        v20[4] = 37;
        int[] v21 = new int[6];
        v21[0] = 20;
        v21[1] = 22;
        v21[2] = 34;
        v21[3] = 35;
        v21[4] = 36;
        v21[5] = 37;
        int[] v22 = new int[4];
        v22[0] = 20;
        v22[1] = 21;
        v22[2] = 26;
        v22[3] = 35;
        int[] v23 = new int[4];
        v23[0] = 25;
        v23[1] = 34;
        v23[2] = 36;
        v23[3] = 38;
        int[] v24 = new int[2];
        v24[0] = 25;
        v24[1] = 34;
        int[] v25 = new int[5];
        v25[0] = 1;
        v25[1] = 23;
        v25[2] = 24;
        v25[3] = 34;
        v25[4] = 38;
        int[] v26 = new int[4];
        v26[0] = 16;
        v26[1] = 20;
        v26[2] = 22;
        v26[3] = 32;
        int[] v27 = new int[4];
        v27[0] = 28;
        v27[1] = 29;
        v27[2] = 30;
        v27[3] = 33;
        int[] v28 = new int[3];
        v28[0] = 5;
        v28[1] = 27;
        v28[2] = 30;
        int[] v29 = new int[5];
        v29[0] = 27;
        v29[1] = 30;
        v29[2] = 31;
        v29[3] = 32;
        v29[4] = 33;
        int[] v30 = new int[4];
        v30[0] = 27;
        v30[1] = 28;
        v30[2] = 29;
        v30[3] = 32;
        int[] v31 = new int[5];
        v31[0] = 16;
        v31[1] = 18;
        v31[2] = 29;
        v31[3] = 32;
        v31[4] = 33;
        int[] v32 = new int[6];
        v32[0] = 20;
        v32[1] = 26;
        v32[2] = 29;
        v32[3] = 30;
        v32[4] = 31;
        v32[5] = 37;
        int[] v33 = new int[4];
        v33[0] = 18;
        v33[1] = 27;
        v33[2] = 29;
        v33[3] = 31;
        int[] v34 = new int[5];
        v34[0] = 21;
        v34[1] = 23;
        v34[2] = 24;
        v34[3] = 25;
        v34[4] = 36;
        int[] v35 = new int[3];
        v35[0] = 21;
        v35[1] = 22;
        v35[2] = 40;
        int[] v36 = new int[5];
        v36[0] = 21;
        v36[1] = 23;
        v36[2] = 34;
        v36[3] = 37;
        v36[4] = 38;
        int[] v37 = new int[4];
        v37[0] = 20;
        v37[1] = 21;
        v37[2] = 32;
        v37[3] = 36;
        int[] v38 = new int[3];
        v38[0] = 23;
        v38[1] = 25;
        v38[2] = 36;
        int[] v39 = new int[3];
        v39[0] = 40;
        v39[1] = 41;
        v39[2] = 42;
        int[] v40 = new int[4];
        v40[0] = 35;
        v40[1] = 39;
        v40[2] = 41;
        v40[3] = 42;
        int[] v41 = new int[3];
        v41[0] = 39;
        v41[1] = 40;
        v41[2] = 42;
        int[] v42 = new int[3];
        v42[0] = 39;
        v42[1] = 40;
        v42[2] = 41;

        t1[0] = new Territorios("Alaska", 1, v1, 3, "America del Norte");
        t1[1] = new Territorios("Alberta", 2, v2, 4, "America del Norte");
        t1[2] = new Territorios("America Central", 3, v3, 3, "America del Norte");
        t1[3] = new Territorios("Estados Unidos del Este", 4, v4, 4, "America del Norte");
        t1[4] = new Territorios("Groenlandia", 5, v5, 4, "America del Norte");
        t1[5] = new Territorios("Territorios del Noroeste", 6, v6, 4, "America del Norte");
        t1[6] = new Territorios("Ontario", 7, v7, 6, "America del Norte");
        t1[7] = new Territorios("Quebec", 8, v8, 3, "America del Norte");
        t1[8] = new Territorios("Estados Unidos del Oeste", 9, v9, 4, "America del Norte");
        t1[9] = new Territorios("Argentina", 10, v10, 2, "America del Sur");
        t1[10] = new Territorios("Brasil", 11, v11, 4, "America del Sur");
        t1[11] = new Territorios("Peru", 12, v12, 3, "America del Sur");
        t1[12] = new Territorios("Venezuela", 13, v13, 3, "America del Sur");
        t1[13] = new Territorios("Congo", 14, v14, 3, "Africa");
        t1[14] = new Territorios("Africa Oriental", 15, v15, 5, "Africa");
        t1[15] = new Territorios("Egipto", 16, v16, 4, "Africa");
        t1[16] = new Territorios("Madagascar", 17, v17, 2, "Africa");
        t1[17] = new Territorios("Africa del Norte", 18, v18, 6, "Africa");
        t1[18] = new Territorios("Sudafrica", 19, v19, 3, "Africa");
        t1[19] = new Territorios("Afghanistan", 20, v20, 5, "Asia");
        t1[20] = new Territorios("China", 21, v21, 6, "Asia");
        t1[21] = new Territorios("India", 22, v22, 4, "Asia");
        t1[22] = new Territorios("Irkutsk", 23, v23, 4, "Asia");
        t1[23] = new Territorios("Japn", 24, v24, 2, "Asia");
        t1[24] = new Territorios("Kamchatka", 25, v25, 5, "Asia");
        t1[25] = new Territorios("Oriente Medio", 26, v26, 4, "Asia");
        t1[26] = new Territorios("Gran Bretaa", 27, v27, 4, "Europa");
        t1[27] = new Territorios("Iceland", 28, v28, 3, "Europa");
        t1[28] = new Territorios("Europa del Norte", 29, v29, 5, "Europa");
        t1[29] = new Territorios("Escandinavia", 30, v30, 4, "Europa");
        t1[30] = new Territorios("Europa del Sur", 31, v31, 5, "Europa");
        t1[31] = new Territorios("Ucrania", 32, v32, 6, "Europa");
        t1[32] = new Territorios("Europa Occidental", 33, v33, 4, "Europa");
        t1[33] = new Territorios("Mongolia", 34, v34, 5, "Asia");
        t1[34] = new Territorios("Siam", 35, v35, 3, "Asia");
        t1[35] = new Territorios("Siberia", 36, v36, 5, "Asia");
        t1[36] = new Territorios("Ural", 37, v37, 4, "Asia");
        t1[37] = new Territorios("Yakutsk", 38, v38, 3, "Asia");
        t1[38] = new Territorios("Australia Oriental", 39, v39, 3, "Australia");
        t1[39] = new Territorios("Indonesia", 40, v40, 4, "Australia");
        t1[40] = new Territorios("Nueva Guinea", 41, v41, 3, "Australia");
        t1[41] = new Territorios("Australia Occidental", 42, v42, 3, "Australia");
        
        for (int i= 0; i < 42; i++)
            t1[i].setTipo_soldado((rnd.nextInt(3) + 1));
    }
    
    //Refuerzos
    public void Refuerzos (Jugador jug) {
        int num_terr= 0, total= 0;
        
        num_terr= jug.getnumTerritorios();
               
        if (num_terr < 12)
            total= 3;
        
        if (num_terr >= 12 && num_terr <= 14)
            total= 4;

        if (num_terr >= 15 && num_terr <= 17)
            total= 5;

        if (num_terr >= 18 && num_terr <= 20)
            total= 6;
        
        if (num_terr >= 21 && num_terr <= 23)
            total= 7;

        if (num_terr >= 24 && num_terr <= 26)
            total= 8;

        if (num_terr >= 27 && num_terr <= 29)
            total= 9;

        if (num_terr >= 30 && num_terr <= 32)
            total= 10;

        if (num_terr >= 33 && num_terr <= 35)
            total= 11;

        if (num_terr >= 36 && num_terr <= 38)
            total= 12;

        if (num_terr >= 39 && num_terr <= 42)
            total= 13;
        
        if (jug.getTerritorioControlado_Cont("America del Norte") == 9)
            total+= 5;

        if (jug.getTerritorioControlado_Cont("America del Sur") == 4)
            total+= 2;
        
        if (jug.getTerritorioControlado_Cont("Africa") == 6)
            total+= 3;
        
        if (jug.getTerritorioControlado_Cont("Asia") == 12)
            total+= 7;
        
        if (jug.getTerritorioControlado_Cont("Europa") == 9)
            total+= 5;
        
        if (jug.getTerritorioControlado_Cont("Australia") == 4)
            total+= 2;
        
        jug.setN_ejercitos(jug.getN_ejercitos() + total);
        
        setChanged();
        notifyObservers((Object)"Refuerzo");                
    }

    
    //Comprueba el estado de la misin del jugador
    public void Estado (Jugador jug) {
        
        this.mision[jug.getNum_mision()-1].setCompletado_obj1(jug.getTerritorioControlado_Cont(this.mision[jug.getNum_mision()-1].getNom_cont1()));
        this.mision[jug.getNum_mision()-1].setCompletado_obj2(jug.getTerritorioControlado_Cont(this.mision[jug.getNum_mision()-1].getNom_cont2()));
        
        setChanged();
        notifyObservers((Object)"Estado");                
    }
    
    //Devuelve el nombre del territorio pasado por la variable val - 1
    public String Nom_Territorio (int val) {
        return t1[val].getNombre();
    }
    
    //Devuelve un territorio pasado por el parametro val
    public Territorios getTerritorio (int val) {
        return t1[val];
    }
    
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.9C23543C-B29F-DF0E-3D0D-4EDC55E51CD3]
    // </editor-fold> 
    public void jugar() {/*
        int op = 0;
        int jug_turno = 0;

        t1[0].setPropietario(1);
        t1[0].setEjercitos(2);
        t1[1].setPropietario(2);
        t1[1].setEjercitos(2);

        do {
            System.out.println("-------------------------------------------------------");
            System.out.println("1.- Mostrar jugador en turno.");
            System.out.println("2.- Modo de Ataque.");
            System.out.println("3.- Invadir Territorio conquistado.");
            System.out.println("4.- Ubicar Tropas.");
            System.out.println("5.- Cambiar Cartas.");
            System.out.println("6.- Terminar Turno del jugador en curso.");
            System.out.println("7.- Salir del programa");
            System.out.print("Escoja una opcin: ");
            op = Teclado.readInt();
            System.out.println("-------------------------------------------------------");

            switch (op) {
                case 1:
                     {
                        System.out.println("Hola soy la persona " + jugadores[jug_turno].getNombre_jug() +
                                " y este es mi turno!");
                    }
                    break;
                case 2:
                     {
                        System.out.println(jugadores[jug_turno].getNombre_jug() +
                                ". Esta en modo de ataque.");
                         int n = Ataque(jugadores[jug_turno]);
                         
                         System.out.println("Volvemos a inicializar los ejercitos para" +
                                 " no tener que cerrar y abrir la aplicacin");
                          t1[0].setEjercitos(2);
                          t1[1].setEjercitos(2);

                    }
                    break;
                case 3:
                     {
                        System.out.println(jugadores[jug_turno].getNombre_jug() +
                                ". Esta invadiendo el territorio conquistado.");
                    }
                    break;
                case 4:
                     {
                        System.out.println(jugadores[jug_turno].getNombre_jug() +
                                ". Esta ubicando las tropas en mis territorios.");
                    }
                    break;
                case 5:
                     {
                        System.out.println(jugadores[jug_turno].getNombre_jug() +
                                ". Estoy cambiando las cartas por tropas.");
                    }
                    break;
                case 6:
                     {
                        System.out.println("Fin de turno del jugador " + jugadores[jug_turno].getId_jug());

                        jug_turno++;
                        jug_turno = jug_turno % num_jugadores;
                    }
                    break;

                default:
                    System.out.println("Saliendo del programa...");
            }
        } while (op != 7);*/
    }

    public int Ataque(Jugador atacador) {/*
        int ter1 = -1;
        int ter2 = -1;
        int ganador=-1;
        System.out.println("Seleccionar el 1 para Alaska y el 2 para Alberta");
        System.out.println("Vuestro territorio: ");
        ter1 = Teclado.readInt()-1;
        int[] vec;
        int nAtacDados;
        int nDefensDados;
        int[] atadados;
        int[] defendados;
        int op= 0;
        int ejer1= 0, ejer2= 0;

        if (atacador.getId_jug() == t1[ter1].getPropietario()) {
            System.out.println("Territorio a atacar: ");
            ter2 = Teclado.readInt()-1;
            vec = new int[t1[ter2].getNVecinos()];
            vec = t1[ter2].getVecinos();
            Boolean vecino = false;

            //buscamos si somos vecinos
            for (int i = 0; i < t1[ter2].getNVecinos(); i++) {
                if ((vec[i]-1) == ter1) {
                    vecino = true;
                       }
            }

            //somos vecinos
            if (vecino == true) {
                Jugador defensor = null;
                defensor = jugadores[(t1[ter2].getPropietario())-1];
                System.out.println("Nmero maximo para los dados es 2 tanto para" +
                        " el ataque como la defensa");
                System.out.println("Atacador, introduce numero de dados: ");
                nAtacDados = Teclado.readInt();
                System.out.println("Defensor, introduce numero de dados: ");
                nDefensDados = Teclado.readInt();

                if (nAtacDados > 2) {
                    nAtacDados = 2;
                }
                if (nAtacDados < 1) {
                    nAtacDados = 1;
                }
                if (nDefensDados > 2) {
                    nDefensDados = 2;
                }
                if (nDefensDados < 1) {
                    nDefensDados = 1;
                }
                System.out.println("JUGAMOOOS");
                atadados = new int[nAtacDados];
                defendados = new int[nDefensDados];


                int atacPrimMax = 0;
                int atacSecMax = 0;
                int atacTresMax = 0;
                int defenPrimMax = 0;
                int defenSecMax = 0;
                int numAta= 0;
                
                
                while (t1[ter1].getEjercitos() != 0 && t1[ter2].getEjercitos() != 0){
                    numAta++;
                    System.out.println("Ataque nmero: "+numAta);
                    ejer1= t1[ter1].getEjercitos(); 
                    ejer2= t1[ter2].getEjercitos();
                    System.out.println("Ejercito del Jugador 1: "+ejer1);
                    System.out.println("Ejercito del Jugador 2: "+ejer2);
                    
                    System.out.println("------------------------------------------------------");
                    for (int i = 0; i < nAtacDados; i++) {
                        atadados[i] = atacador.getDados()[i].getValorCara();
                        //System.out.println("Atacador Dado "+(i+1)+": "+atadados[i]);
                    }
                    for (int i = 0; i < nDefensDados; i++) {
                        defendados[i] = defensor.getDados()[i].getValorCara();
                        //System.out.println("Defendador Dado "+(i+1)+": "+defendados[i]);
                    }
                    atadados= OrdenaMay_Men(atadados,nAtacDados);
                    defendados= OrdenaMay_Men(defendados,nDefensDados);
                    
                    System.out.println("Ordenamos los dados de mayor a menor");

                    for (int i = 0; i < nAtacDados; i++) {
                        System.out.println("Atacador Dado "+(i+1)+": "+atadados[i]);
                    }
                    for (int i = 0; i < nDefensDados; i++) {
                        System.out.println("Defendador Dado "+(i+1)+": "+defendados[i]);
                    }
                    
                    switch (nDefensDados){
                        case 1: defenPrimMax= defendados[0];
                                break;
                        case 2: defenPrimMax= defendados[0];
                                defenSecMax= defendados[1];
                                break;
                    }
                    
                    switch (nAtacDados){
                        case 1: atacPrimMax= atadados[0];
                                break;
                        case 2: atacPrimMax= atadados[0];
                                atacSecMax= atadados[1];
                                break;
                        case 3: atacPrimMax= atadados[0];
                                atacSecMax= atadados[1];
                                atacTresMax= atadados[2];
                                break;    
                    }
                    
                    if (nAtacDados > nDefensDados)
                        op= nDefensDados;
                    
                    if (nAtacDados < nDefensDados)
                        op= nAtacDados;
                    
                    if (nAtacDados == nDefensDados)
                        op= nAtacDados;
                    
                    switch (op){
                        case 1: 
                                if (atacPrimMax > defenPrimMax){
                                    System.out.println("Jugador "+t1[ter2].getPropietario()+ " pierde un ejercito");
                                    t1[ter2].setEjercitos(t1[ter2].getEjercitos()- 1);
                                    //nDefensDados--;
                                }
                    
                                if (atacPrimMax < defenPrimMax){
                                   System.out.println("Jugador "+t1[ter1].getPropietario()+ " pierde un ejercito");
                                    t1[ter1].setEjercitos(t1[ter1].getEjercitos()- 1);
                                    //nAtacDados--;
                                }
                                break;
                        case 2: 
                                if (atacPrimMax > defenPrimMax){
                                    System.out.println("Jugador "+t1[ter2].getPropietario()+ " pierde un ejercito");
                                    t1[ter2].setEjercitos(t1[ter2].getEjercitos()- 1);
                                    nDefensDados--;
                                }
                    
                                if (atacPrimMax < defenPrimMax){
                                    System.out.println("Jugador "+t1[ter1].getPropietario()+ " pierde un ejercito");
                                    t1[ter1].setEjercitos(t1[ter1].getEjercitos()- 1);
                                    nAtacDados--;
                                }
                                
                                if (atacSecMax > defenSecMax){
                                    System.out.println("Jugador "+t1[ter2].getPropietario()+ " pierde un ejercito");
                                    t1[ter2].setEjercitos(t1[ter2].getEjercitos()- 1);
                                    nDefensDados--;
                                }
                    
                                if (atacSecMax < defenSecMax){
                                    System.out.println("Jugador "+t1[ter1].getPropietario()+ " pierde un ejercito");
                                    t1[ter1].setEjercitos(t1[ter1].getEjercitos()- 1);
                                    nAtacDados--;
                                }
                                break;
                    }
                }
                
                if (t1[ter1].getEjercitos() != 0)
                    ganador= atacador.getId_jug();

                if (t1[ter2].getEjercitos() != 0)
                    ganador= defensor.getId_jug();
                

                /*do {
                    for (int i = 0; i < nAtacDados; i++) {
                        atadados[i] = atacador.getDados()[i].getValorCara();
                        System.out.println("Atacador: "+atadados[i]);
                    }
                    for (int i = 0; i < nDefensDados; i++) {
                        defendados[i] = defensor.getDados()[i].getValorCara();
                        System.out.println("Defendador: "+defendados[i]);
                    }

                    if (nAtacDados > 1) {
                        for (int i = 0; i < nAtacDados; i++) {

                            if (atadados[i] > defenPrimMax) {
                                atacPrimMax = atadados[i];
                            }
                        }
                        for (int i = 0; i < nAtacDados; i++) {

                            if ((atadados[i] > atacSecMax) && ((atadados[i] < atacPrimMax))) {
                                atacSecMax = atadados[i];
                            }
                        }
                    } else {
                        atacPrimMax = atadados[0];
                        atacSecMax = atacPrimMax;
                    }

                    if (nDefensDados > 1) {
                        for (int i = 0; i < nDefensDados; i++) {

                            if (defendados[i] > defenPrimMax) {
                                defenPrimMax = defendados[i];
                            }
                        }
                        for (int i = 0; i < nDefensDados; i++) {

                            if ((defendados[i] > defenSecMax) && ((defendados[i] < defenPrimMax))) {
                                defenSecMax = defendados[i];
                            }
                        }
                    } else {
                        defenPrimMax = defendados[0];
                        defenSecMax = defenPrimMax;
                    }


                    
                        if (atacPrimMax > defenPrimMax) {
                            nDefensDados -= 1;

                        } else {
                            nAtacDados -= 1;
                        }



                        if (atacSecMax > defenSecMax) {
                            nDefensDados -= 1;
                        } else {
                            nAtacDados -= 1;
                        }

                    
                } while (nAtacDados == 1 || nDefensDados == 0);*/
                 
               /* if (nDefensDados==0){
                ganador= atacador.getId_jug();               
                t1[ter2].setEjercitos(nAtacDados-1);
                                
                }
                else {ganador= defensor.getId_jug();
                     t1[ter2].setEjercitos(nDefensDados-1);}
                
                t1[ter2].setPropietario(ganador);
                
            } //vecino==true
            else {
                System.out.println("El Territorio "+t1[ter2].getNombre()+" no hace" +
                        " frontera con "+t1[ter1].getNombre());
                return -1;
            }


        } else {
            ganador= -1;
        }

        System.out.println("Jugador "+ganador+" ha ganado.");*/
        return 0;

    }
       
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D2400125-5319-0A6E-7499-50E3918C2398]
    // </editor-fold> 

    public int getModo_juego() {
        return this.modo_juego;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8CC0F906-FC21-44F4-2533-30CA25AB4484]
    // </editor-fold> 
    public void setModo_juego(int val) {
        this.modo_juego= val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D1A878A5-B212-32C2-1452-C2F232F514EF]
    // </editor-fold> 
    public int getNum_jugadores() {
        return this.num_jugadores;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.463E5FEB-8D51-7D89-0D3A-F360FDF301A6]
    // </editor-fold> 
    public void setNum_jugadores(int val) {
        this.num_jugadores= val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.38B2C4BF-DC83-90D6-FC2D-EAFD55531538]
    // </editor-fold> 
    public void turno(Jugador jug) {
        
       if (this.num_jugadores != 1){ 
        if (jug.getnumTerritorios() == 0){
            jug.setEliminado(true);
            this.num_jugadores--;
            setChanged();
            notifyObservers((Object)"Eliminado");        
        }
       } 
        
        if (jug.getnumTerritorios() == 42){
            setChanged();
            notifyObservers((Object)"Ganador");        
        }
        else{
            setChanged();
            notifyObservers((Object)"Fin Turno");        
        }    
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1A5E091F-1F52-1A39-1CC1-BBC12E7DAA2B]
    // </editor-fold> 
    public Dados getDados() {
        return mDados;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E39471E2-DBA6-5AF0-8A70-5A7F87C8B1BF]
    // </editor-fold> 
    public void setDados(Dados val) {
        this.mDados = val;
    }

}

